Lattice Grid Buy a licence

demo D228

Confidence intervals, charted

The mean lead time of each supplier with its 95% interval as a whisker, and a tile that narrows as you filter

grid.statistics.interval(col) · chart error: true

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid, createStat } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/charts.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'supplier', title: 'Supplier', filter: { type: 'set' } },
    { field: 'days', title: 'Lead time', type: 'number', format: { suffix: ' d', maximumFractionDigits: 1 }, total: 'avg' },
  ];

  const rows = [/* e.g. [{ id: 'O0', supplier: 'Kestrel', days: 3.1 }, ...] */];

  function App() {
    const gridRef = React.useRef(null);

    React.useEffect(() => {
      const grid = gridRef.current.grid;
      const tile = document.getElementById('tiles').appendChild(document.createElement('div'));

      // interval() is the range the mean is pinned to, computed over the filtered
      // rows. The tile shows it under the value; ask for a proportion with
      // { kind: 'proportion' } and a rule for what counts as a success.
      createStat({ grid, container: tile, title: 'Mean lead time', of: 'days', fn: 'avg',
        interval: (value, grid) => grid.statistics.interval('days'), footer: '95% confidence interval' });

      // error: true draws each mean's interval as a whisker, computed from the
      // readings behind the bar. The chart reads the same grid as the tile, so
      // the bars and the whiskers follow the filters.
      createChart({ grid, container: '#chart', type: 'bar', x: 'supplier', y: { col: 'days', fn: 'avg' },
        error: true, title: 'Mean lead time by supplier, with confidence interval' });
    }, []);

    return (
      <>
        <div id="chart" style={{ height: '250px' }} />
        <div id="tiles" style={{ display: 'grid', gridTemplateColumns: 'repeat(3, 1fr)', gap: '12px', margin: '14px 0' }} />
        <LatticeGrid
          ref={gridRef}
          rowKey="id"
          toolPanel={{ side: 'left', panels: ['filters', 'columns', 'statistics'] }}
          columns={columns}
          rows={rows}
          style={{ height: '340px' }}
        />
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Lattice Grid Buy a licence

demo D228

Confidence intervals, charted

The mean lead time of each supplier with its 95% interval as a whisker, and a tile that narrows as you filter

grid.statistics.interval(col) · chart error: true

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid, createStat } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createChart } from '@toclocoinc/lattice-grid/modules/charts';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<div #chart style="height:250px"></div>' +
    '<div #tiles style="display:grid;grid-template-columns:repeat(3,1fr);gap:12px;margin:14px 0"></div>' +
    '<lattice-grid [config]="grid" style="display:block;height:340px"></lattice-grid>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild('chart') chartEl!: ng.ElementRef<HTMLElement>;
  @ViewChild('tiles') tilesEl!: ng.ElementRef<HTMLElement>;
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;

  grid = {
    rowKey: 'id',
    toolPanel: { side: 'left', panels: ['filters', 'columns', 'statistics'] },
    columns: [
      { field: 'supplier', title: 'Supplier', filter: { type: 'set' } },
      { field: 'days', title: 'Lead time', type: 'number', format: { suffix: ' d', maximumFractionDigits: 1 }, total: 'avg' },
    ],
    rows: [/* e.g. { id: 'O0', supplier: 'Kestrel', days: 3.1 } */],
  };

  ngAfterViewInit() {
    const grid = this.gridRef.grid;
    const tile = this.tilesEl.nativeElement.appendChild(document.createElement('div'));

    // interval() is the range the mean is pinned to, computed over the filtered
    // rows. The tile shows it under the value.
    createStat({ grid, container: tile, title: 'Mean lead time', of: 'days', fn: 'avg',
      interval: (value: any, g: any) => g.statistics.interval('days'), footer: '95% confidence interval' });

    // error: true draws each mean's interval as a whisker, computed from the
    // readings behind the bar. The chart reads the same grid as the tile.
    createChart({ grid, container: this.chartEl.nativeElement, type: 'bar', x: 'supplier', y: { col: 'days', fn: 'avg' },
      error: true, title: 'Mean lead time by supplier, with confidence interval' });
  }
}

bootstrapApplication(AppComponent);